#include "defs.h"
#include <stdio.h>
#include <math.h>
#include "imageio.h"

int enlight(ImagePtr* dest, ImagePtr imsource,int value) {
/*Modifies the brightness of the source image
  and saves this into dest*/

   ImagePtr imdest;		/*VarPointers to the Image Data*/
   int t,tt,actual,sum;		/*Several integers*/
   int x,y;
   int color[256];		/*Some sort of Color Map*/
   float modi,tmp;		/*Image calculation floats*/

#ifdef USE_DEBUG
   fprintf(stderr,"Running enlighten with value %i...\n",value);
#endif

   imdest   = createim(widthim(imsource),heightim(imsource));
   *dest=imdest;
   /*We create a destination image the size of the source*/
   /*and give its adress back*/

   t=0;
   while (t<256) {
      color[t]=collorallocateim(imdest,t,t,t);
      t++;
   }
   /*We create some sort of 256 colors b/w colormap for the destination*/

   t=0;
   sum=0;
   x=widthim(imdest);
   y=heightim(imdest);
   modi=(value/100.0);
   while (t<x) {
      tt=0;
      while (tt<y) {
         actual=pixelbrightim(imsource,t,tt);
	 tmp=floor(actual*modi);
	 sum+=tmp-actual;
	 actual=tmp;
	 if (actual<0) actual=0;
	 if (actual>255) actual=255;
         drawpixelim(imdest,t,tt,color[actual]);
	 tt++;
      }
      t++;
   }
   /*Main Working stuff, this is important!
     Go through every pixel of the source image and set the
     corrseponding pixel of the destination image to the
     corresponding grey-value of the source pixel modified
     by value percent. Value=20 means image gets 120% brightness.
     Simple routine, but could be useful for several things */


  return sum;
  /*and we are finnished*/

}


