/* imageio: basic image functions*/

typedef void* ImagePtr;
/*an Image pointer*/

ImagePtr loadim(char* filename);
/*Loads an Image*/
/*Returns ImagePtr to image structure if succesfull and NULL if not*/

int saveim(ImagePtr im, char* filename);
/*Saves the Image in a file*/
/*Returns null if sucessfull and -1 if not*/

inline ImagePtr createim(int width, int height);
/*Creates an Image*/
/*Returns ImagePtr to image structure if succesfull and NULL if not*/

inline int destroyim (ImagePtr im);
/*Frees image memory*/

inline int widthim(ImagePtr im);
/*Returns the images X width*/

inline int heightim(ImagePtr im);
/*Returns the images Y height*/

inline int collorallocateim(ImagePtr im,int r,int g,int b);
/*Allocates a color structure*/
/*Returns an ID integer of this*/

inline int pixelbrightcim(int r, int g, int b);
/*Gives back the corresponding pixelbrightness*/
/*of color r g b*/

inline int pixelbrightim(ImagePtr im,int x,int y);
/*Gives back the pixelbrightness at x,y in im*/
/*Gives back 0 if error (x,y out of range or so)*/

inline int pixelredim(ImagePtr im,int x,int y);
/*Gives back the pixelredness at x,y in im*/
/*Gives back 0 if error (x,y out of range or so)*/

inline int pixelgreenim(ImagePtr im,int x,int y);
/*Gives back the pixelgreenness at x,y in im*/
/*Gives back 0 if error (x,y out of range or so)*/

inline int pixelblueim(ImagePtr im,int x,int y);
/*Gives back the pixelblueness at x,y in im*/
/*Gives back 0 if error (x,y out of range or so)*/

inline int srnddifim(ImagePtr im,int x, int y);
/*Gives back the delta pixelbrightness around x,y in im*/
/*Assumes brightness 0 for pixels out of image*/

inline int srndavgim(ImagePtr im,int x, int y);
/*Gives back the average pixelbrightness around x,y in im*/
/*Assumes brightness 0 for pixels out of image*/

inline int xsectorsim(ImagePtr im,int sectorsize);
inline int ysectorsim(ImagePtr im,int sectorsize);
/*Give back the amount of sectors in x and y direction in im*/

inline int sectorbrightim(ImagePtr im,int xpos,int ypos,int sectorsize);
/*Gives back the average brightness of a specified sector*/
/*As always pixels out of the image are 0*/

inline int drawpixelim(ImagePtr im,int x,int y,int color);
/*Draws a Pixel into im*/
/*0 if OK, -1 if failed*/

inline int drawsectorim(ImagePtr im,int xpos, int ypos, int color,int sectorsize);
/*Draws or Outlines a sector in im, not sure yet <g>*/
/*0 if OK, -1 if i am not too lacy to detect errors here <g>*/

