#include "defs.h"
#include <stdio.h>
#include <stdlib.h>
#include "imageio.h"
#include "patternlist.h"

struct patternfield {
   int width;
   int height;
   int *pattern;
};

struct patternfield pattern(	ImagePtr* dest, ImagePtr imsource,
				int patternwidth, int patternheight, int width, struct patternlist* list) {
/*Does a pattern search in imsource, saves a aptternam in imdest
  and gives back a struct patternfield (uses patternlist list of course*/

   ImagePtr imdest;			/*VarPointers to the Image Data*/
   int t,tt,i,ii,tx,ty,sx,sy,x,y,actual,sum;	/*Several integers*/
#ifdef USE_SPEEDHACK
   int zx,zy,zzx,zzy;
#endif
   int color[256];			/*Some sort of Color Map*/
   int *icon, *icon2;			/*Patterndata*/ 
   struct patternmatch pactual;		/*Temp var to save the match class result*/
   struct patternfield returnval;	/*Obvious isnt it?*/
   int* returnpatterndata;		/*field with the patterns found*/

#ifdef USE_DEBUG
   fprintf(stderr,"Running pattern search  width %ix%i patterns and %i threshold...\n",
      patternwidth,patternheight,width);
#endif

   icon=(int*)malloc(sizeof(int[patternwidth*patternheight]));
   /*Initialize Buffer for the pattern to check*/
   
   imdest = createim(widthim(imsource),heightim(imsource));
   *dest=imdest;
   /*We create a destination image the size of the source*/
   /*and give its adress back*/

   t=0;
   while (t<256) {
      color[t]=collorallocateim(imdest,t,t,t);
      t++;
   }
   /*We create some sort of 256 colors b/w colormap for the destination*/
   /*Later there will be even greyscale patterns, now as i write this thers only
     that b&w asciitable, but why should it be limited?*/
   
   t=0;
   x=widthim(imdest)/patternwidth;
   y=heightim(imdest)/patternheight;
#ifdef USE_SPEEDHACK
   zzx=widthim(imdest);
   zzy=heightim(imdest);
#endif
   returnval.width=x;
   returnval.height=y;
   returnpatterndata=(int*)malloc(sizeof(int[x*y]));
   returnval.pattern=returnpatterndata;
   while (t<y) {
      tt=0;
      while (tt<x) {
         tx=patternwidth*tt;
	 ty=patternheight*t;
	 actual=-1;
         sum=-1;
	 sy=-width;
	 while (sy<width+1) {
	    sx=-width;
	    while (sx<width+1) {
	       i=0;
	       while (i<patternheight) {
	          ii=0;
	          while (ii<patternwidth) {
#ifdef USE_SPEEDHACK
/*we better dont create a segfault here*/
		     zx=sx+tx+ii;zy=sy+ty+i;
                     if (zx>=0 && zx<zzx && zy>=0 && zy<zzy)
                        icon[i*patternwidth+ii]=pixelbrightim(imsource,zx,zy);
#else
	             icon[i*patternwidth+ii]=pixelbrightim(imsource,sx+tx+ii,sy+ty+i);
#endif
	             ii++;
	          }
	          i++;
	       }
               /*Filled the pattern buffer, now trying for best match*/
	       pactual= patternlist_bestmatch (list,patternwidth,patternheight,icon);
	       if (pactual.differ<sum || sum<0) {
	          actual=pactual.patident;
		  sum=pactual.differ;
	       }
	          
	       sx++;
	    }
	    sy++;
         }
	 /*We test best match against width*width different positions to catch THE pattern
	   more likely */
	 sx=patternlist_patternwidth(list,actual);
	 sy=patternlist_patternheight(list,actual);
	 icon2=patternlist_pattern(list,actual);
	 i=0;
	 while (i<sy) {
	    ii=0;
	    while (ii<sx) {
#ifdef USE_SPEEDHACK
/*we better dont create a segfault here*/
               zx=tx+ii;zy=ty+i;
               if (zx>=0 && zx<zzx && zy>=0 && zy<zzy)
	          drawpixelim(imdest,zx,zy,icon2[i*sx+ii]);
#else
	       drawpixelim(imdest,tx+ii,ty+i,icon2[i*sx+ii]);
#endif
	       ii++;
	    }
	    i++;
	 }
	 /*We save the matching pattern in imdest*/
	 
	 returnpatterndata[t*x+tt]=actual;
	 /*And in the return var*/
	 tt++;
      }
      t++;
  }
  free(icon);
  return returnval;
  /*and we are finnished*/

}


